
using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Rename.Models;

public record Configuration(Metadata.Models.MetadataConfiguration MetadataConfiguration,
                            bool ForceMetadataLastWriteTimeToCreationTime,
                            string[] IgnoreExtensions,
                            string PersonBirthdayFormat,
                            bool PropertiesChangedForMetadata)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, ConfigurationSourceGenerationContext.Default.Configuration);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true)]
[JsonSerializable(typeof(Configuration))]
internal partial class ConfigurationSourceGenerationContext : JsonSerializerContext
{
}